Unit QST2R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, UTQS10_p;

procedure QST2R(var RINT :Array of Real; A :Real; B :Real;
                F :Proc_F3_A; N :Integer; EPS :Real; K :Integer;
                var IND :Array of Integer; var R :Array of Real;
                var IERR :Integer);

implementation

procedure QST2R(var RINT :Array of Real; A :Real; B :Real;
                F :Proc_F3_A; N :Integer; EPS :Real; K :Integer;
                var IND :Array of Integer; var R :Array of Real;
                var IERR :Integer);
var
I,K1,K2,J :Integer;
E,H,RH,RI :Real;
label
_1,_10,_1000,_20,_1001,_30,_40,_50,_1002,_60,_1003,_70,_80,_1004,_90,
_1005,_100;
begin
_1:
IERR := 0;
for I:=1 to N do
 begin
  R[(I-1)+1*N] := 0.0;
  IND[I-1] := 0;
_10:
 end;
_1000:
K1 := K;
if ( K  <=  0 ) 
 then K1 := 1;
F(A,RINT,IND);
F(B,R,IND);
H := (B - A)/K1;
for I:=1 to N do
 begin
  RINT[I-1] := (RINT[I-1] + R[(I-1)+0*N])*H*0.5;
_20:
 end;
_1001:
if ( K1  =  1 ) 
 then goto _50;
K2 := K1 - 1;
for J:=1 to K2 do
 begin
  F(A + J*H,R,IND);
  for I:=1 to N do
   begin
    RINT[I-1] := RINT[I-1] + R[(I-1)+0*N]*H;
_30:
   end;
_40:
 end;
_50:
_1002:
if ( EPS  <=  0.0 ) 
 then goto _100;
_60:
_1003:
H := H*0.5;
for J:=1 to K1 do
 begin
  F(A + (2.0*J - 1.0)*H,R,IND);
  for I:=1 to N do
   begin
    R[(I-1)+1*N] := R[(I-1)+1*N] + R[(I-1)+0*N];
_70:
   end;
_80:
 end;
_1004:
K2 := 1;
for I:=1 to N do
 begin
  if ( IND[I-1]  >  0 ) 
   then goto _90;
  RH := R[(I-1)+1*N]*H;
  RI := RINT[I-1]*0.5;
  RINT[I-1] := RH + RI;
  E := Abs(RH-RI)/(1.0 + Abs(RINT[I-1]));
  if ( E  <=  EPS ) 
   then IND[I-1] := K1;
  if ( IND[I-1]  =  0 ) 
   then K2 := 0;
  R[(I-1)+1*N] := 0.0;
_90:
 end;
if ( K2  >  0 ) 
 then goto _100;
K1 := K1 + K1;
if ( K1  <=  1048576 ) 
 then goto _60;
_1005:
IERR := 65;
UTQS10(IERR,8);
_100:
end;

end.
